From 57d82991c966137ddbfa18772435bd4de351a44a Mon Sep 17 00:00:00 2001
From: Christopher Bradshaw <chris.kofox@gmail.com>
Date: Fri, 13 Dec 2024 15:57:29 -0700
Subject: [PATCH 09/10] fix(typescript): resolve the shim used for tsc in
 Typescript v5.7 and up (#252)

---
 packages/typescript/lib/quickstart/runTsc.ts | 39 +++++++++++++-------
 1 file changed, 26 insertions(+), 13 deletions(-)

diff --git a/packages/typescript/lib/quickstart/runTsc.ts b/packages/typescript/lib/quickstart/runTsc.ts
index dfb99703..370907a3 100644
--- a/packages/typescript/lib/quickstart/runTsc.ts
+++ b/packages/typescript/lib/quickstart/runTsc.ts
@@ -1,4 +1,5 @@
 import * as fs from 'fs';
+import * as path from 'path';
 import type * as ts from 'typescript';
 import type { Language, LanguagePlugin } from '@volar/language-core';
 
@@ -18,25 +19,37 @@ export function runTsc(
 ) {
 	getLanguagePlugins = _getLanguagePlugins;
 
+	let extraSupportedExtensions: string[];
+	let extraExtensionsToRemove: string[];
+
+	if (Array.isArray(options)) {
+		extraSupportedExtensions = options;
+		extraExtensionsToRemove = [];
+	}
+	else {
+		extraSupportedExtensions = options.extraSupportedExtensions;
+		extraExtensionsToRemove = options.extraExtensionsToRemove;
+	}
+
 	const proxyApiPath = require.resolve('../node/proxyCreateProgram');
 	const readFileSync = fs.readFileSync;
 
 	(fs as any).readFileSync = (...args: any[]) => {
 		if (args[0] === tscPath) {
 			let tsc = (readFileSync as any)(...args) as string;
-
-			let extraSupportedExtensions: string[];
-			let extraExtensionsToRemove: string[];
-			if (Array.isArray(options)) {
-				extraSupportedExtensions = options;
-				extraExtensionsToRemove = [];
-			}
-			else {
-				extraSupportedExtensions = options.extraSupportedExtensions;
-				extraExtensionsToRemove = options.extraExtensionsToRemove;
+			try {
+				return transformTscContent(tsc, proxyApiPath, extraSupportedExtensions, extraExtensionsToRemove, __filename, typescriptObject);
+			} catch {
+				// Support the tsc shim used in Typescript v5.7 and up
+				const requireRegex = /module\.exports\s*=\s*require\((?:"|')(?<path>\.\/\w+\.js)(?:"|')\)/;
+				const requirePath = requireRegex.exec(tsc)?.groups?.path;
+				if (requirePath) {
+					tsc = readFileSync(path.join(path.dirname(tscPath), requirePath), 'utf8');
+					return transformTscContent(tsc, proxyApiPath, extraSupportedExtensions, extraExtensionsToRemove, __filename, typescriptObject);
+				} else {
+					throw new Error('Failed to locate tsc module path from shim');
+				}
 			}
-
-			return transformTscContent(tsc, proxyApiPath, extraSupportedExtensions, extraExtensionsToRemove, __filename, typescriptObject);
 		}
 		return (readFileSync as any)(...args);
 	};
@@ -112,7 +125,7 @@ function replace(text: string, ...[search, replace]: Parameters<String['replace'
 	text = text.replace(search, replace);
 	const after = text;
 	if (after === before) {
-		throw 'Search string not found: ' + JSON.stringify(search.toString());
+		throw new Error('Failed to replace: ' + search);
 	}
 	return after;
 }

